using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace VALCam_SDK_2005_Sample_1
{
    public partial class Adjust : Form
    {
        public  enum  eZoomType { Wide, Medium, Tight};
        public eZoomType ZoomType;
        private int firstTime = 0;
        public Adjust()
        {
            InitializeComponent();
        }
        /*
        public struct structFaceFinder
        {
            public float FacePositionX;
            public float FacePositionY;
            public float EyeDistance;
            public int Glasses;
            public int EyesOpen;
            public int MouthClosed;
            public float FaceWidth;
            public float FaceHeight;
            public float ImageWidth;
            public float ImageHeight;
            float FaceConfidence;
            float Eye1Confidence;
            float Eye2Confidence;

            public int FaceFound;
            public int AutoCenter;
            public int OffsetX;
            public int OffsetY;

            public string FileName;
            public int SampleFromStream;
        };
        
         */
         //structFaceFinder FaceParameters;

        private void hScrollBarRed_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iRedGain = hScrollBarRed.Value;
            Form1.VALCam_Control(Form1.VC_SetRedLive, Form1.iRedGain, 0, 0, 0);
        }

        private void hScrollBarBlue_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iBlueGain = hScrollBarBlue.Value;
            Form1.VALCam_Control(Form1.VC_SetBlueLive, Form1.iBlueGain, 0, 0, 0);

        }

        private void hScrollBarColor_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iColorGain = hScrollBarColor.Value;
            Form1.VALCam_Control(Form1.VC_SetColorLive, Form1.iColorGain, 0, 0, 0);
        }

        private void radioBtnWhiteOn_CheckedChanged(object sender, EventArgs e)
        {
            if (radioBtnWhiteOn.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_AutoWhite, 1, 0, 0, 0);
                Form1.iAutoWhite = 1;
                hScrollBarBlue.Value = 0;
                hScrollBarRed.Value = 0;
                hScrollBarBlue.Enabled = false;
                hScrollBarRed.Enabled = false;
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioBtnWhiteOff.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_AutoWhite, 0, 0, 0, 0);
                Form1.iAutoWhite = 0;
                hScrollBarBlue.Enabled = true;
                hScrollBarRed.Enabled = true;
            }
        }

        private void hScrollBarFlashRed_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iFlashRedGain = hScrollBarFlashRed.Value;
            Form1.VALCam_Control(Form1.VC_SetRedFlash, Form1.iFlashRedGain, 0, 0, 0);
        }

        private void hScrollBarFlashBlue_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iFlashBlueGain = hScrollBarFlashBlue.Value;
            Form1.VALCam_Control(Form1.VC_SetBlueFlash, Form1.iFlashBlueGain, 0, 0, 0);
        }

        private void hScrollBarFlashColor_Scroll(object sender, ScrollEventArgs e)
        {
            Form1.iFlashColorGain = hScrollBarFlashColor.Value;
            Form1.VALCam_Control(Form1.VC_SetRedFlash, Form1.iFlashRedGain, 0, 0, 0);
        }

        private void radioBtnFlourscentOn_CheckedChanged(object sender, EventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_SetFlashColorCorrectionType, 1, 0, 0, 0);
            Form1.iFlashCorrectionType = 1;
        }

        private void radioBtnFlourscentOff_CheckedChanged(object sender, EventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_SetFlashColorCorrectionType, 0, 0, 0, 0);
            Form1.iFlashCorrectionType = 0;
        }

        private void btnResize_Click(object sender, EventArgs e)
        {
            ResizeVideo2();

        }

        private void Adjust_Load(object sender, EventArgs e)
        {
            //************ Update Cropping Control ********************************
            txtCropWidth.Text = Form1.iHSize.ToString();
            txtCropHeight.Text = Form1.iVSize.ToString();
            txtXCropOffset.Text = Form1.iXCropStart.ToString();
            txtYCropOffset.Text = Form1.iYCropStart.ToString();
            txtDisplayScaleX.Text = Form1.iHScale.ToString();
            txtDisplayScaleY.Text = Form1.iVScale.ToString();
            //*********************************************************************
            XCenterOffset.Value = Form1.iXCenterOffset;
            YCenterOffset.Value = Form1.iYCenterOffset;

            firstTime = 0;
            switch (Form1.iRotatePosition)
            {
                case 0:
                    radioButtonRotate0.Checked = true;
                    break;
                case 90:
                    radioButtonRotate90.Checked = true;
                    break;
                case 270:
                    radioButtonRotate270.Checked = true;
                    break;
            }



            //************** Update Flesh Tone **********************************************
            hScrollBarRed.Value = Form1.iRedGain;
            hScrollBarBlue.Value = Form1.iBlueGain;
            hScrollBarColor.Value = Form1.iColorGain;

            hScrollBarFlashRed.Value = Form1.iFlashRedGain;
            hScrollBarFlashBlue.Value = Form1.iFlashBlueGain;
            hScrollBarFlashColor.Value = Form1.iFlashColorGain;



            if (Form1.iAutoWhite == 1)
            {
                radioBtnWhiteOn.Checked = true;
            }
            else
            {
                radioBtnWhiteOff.Checked = true;
            }

            //*******************************************************************************

            //****************** Update Advanced Page ***************************
            numericUpDownSharpness.Value = Form1.iCaptureSharpness;
            numericUpDownFrameGrabber.Value = Form1.FGSharpness;//m_Sharpness = m_pParent->m_Sharpness;

            //****************** Face Locator ***************************
            trackBarMeasuredZoom.Value = Form1.iZoomArray;
            txtMeasuredZoom.Text = Form1.iZoomArray.ToString();
            if (radioButtonCaptureFromStream.Checked == true)
            {
                txtFileNameToSample.Enabled = true;
            }


            //******************************** Capture*****************************************************
            txtFileName.Text = Form1.iFileName;
            if ((radioButtonBMP.Checked == true) || (radioButtonJPG.Checked == true) || (radioButtonJPGBMP.Checked == true))
            {
                txtFileName.Enabled = true;
                txtJPGCompression.Enabled = true;
            }
            else
            {
                txtFileName.Enabled = false;
            }
            txtJPGCompression.Text = Form1.iJPGCompression.ToString();


            txtFileNameToSample.Enabled = true;
            txtFileNameToSample.Text = txtFileName.Text;//Form1.iFileName;
            switch (Form1.iCaptureType)
            {
                case 0:
                    radioButtonDDB.Checked = true;
                    break;
                case 1:
                    radioButtonDIB.Checked = true;
                    break;
                case 2:
                    radioButtonClipBoard.Checked = true;
                    break;
                case 3:
                    radioButtonBMP.Checked = true;
                    break;
                case 4:
                    radioButtonJPG.Checked = true;
                    break;
                case 5:
                    radioButtonJPGBMP.Checked = true;
                    break;
            }


            //************************************************************
            if (Form1.iFlashCorrectionType == 1)
                radioBtnFlourscentOn.Checked = true;
            else
                radioBtnFlourscentOff.Checked = true;


            switch (Form1.iPTZSpeed)
            {
                case 0:
                    radioButtonZoomMed.Checked = true;
                    break;

                case 1:
                    radioButtonZoomMed.Checked = true;
                    break;

                case 2:
                    radioButtonZoomMed.Checked = true;
                    break;
            }
            int ZoomValue;
            ZoomValue = (Form1.VALCam_Control(Form1.VC_ReadZoomPosition, 0, 0, 0, 0));

            txtReadZoom.Text = ZoomValue.ToString();
            trackBarZoom.Value = ZoomValue;
            //************************************************ Flourscent Buttons *************************************

           //*************************** Set Zoom Subject Distance ***********************************

            radioButtonMedium.Checked = true;
            
            /*
            switch (Form1.iZoomArray)
            {
                case 1:
                    comboBox1.

        
        
        
        */
        
        }
            


        private void btnColorDefaults_Click(object sender, EventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_SetPreviewDefaults, 0, 0, 0, 0);
            Form1.VALCam_Control(Form1.VC_SetFlashDefaults, 0, 0, 0, 0);

            hScrollBarRed.Value = Form1.VALCam_Control(Form1.VC_ReturnLiveRed, 0, 0, 0, 0);
            hScrollBarBlue.Value = Form1.VALCam_Control(Form1.VC_ReturnLiveBlue, 0, 0, 0, 0);
            hScrollBarColor.Value = Form1.VALCam_Control(Form1.VC_ReturnLiveColor, 0, 0, 0, 0);

            hScrollBarFlashRed.Value = Form1.VALCam_Control(Form1.VC_ReturnFlashRed, 0, 0, 0, 0);
            hScrollBarFlashBlue.Value = Form1.VALCam_Control(Form1.VC_ReturnFlashBlue, 0, 0, 0, 0);
            hScrollBarFlashColor.Value = Form1.VALCam_Control(Form1.VC_ReturnFlashColor, 0, 0, 0, 0);
        }

        private void numericUpDownSharpness_ValueChanged(object sender, EventArgs e)
        {
            Form1.iCaptureSharpness = (int)numericUpDownSharpness.Value;

            Form1.FGSharpness = (int)numericUpDownFrameGrabber.Value;
            Form1.VALCam_Control(Form1.VC_SetFrameGrabberSharpness, Form1.FGSharpness, 0, 0, 0);
        }

        private void btnReadZoom_Click(object sender, EventArgs e)
        {
            int ZoomValue;
            ZoomValue = (Form1.VALCam_Control(Form1.VC_ReadZoomPosition, 0, 0, 0, 0));
            txtReadZoom.Text = ZoomValue.ToString();
        }

        private void trackBarZoom_Scroll(object sender, EventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_SetZoomPosition, (int)trackBarZoom.Value, 0, 0, 0);
        }

        private void BtnZoomIn_Click(object sender, EventArgs e)
        {
            switch (Form1.iPTZSpeed)
            {
                case 0:
                    Form1.VALCam_Control(Form1.VC_ZoomInSlow, 0, 0, 0, 0);
                    break;

                case 1:
                    Form1.VALCam_Control(Form1.VC_ZoomIn, 0, 0, 0, 0);
                    break;

                case 2:
                    Form1.VALCam_Control(Form1.VC_ZoomInFast, 0, 0, 0, 0);
                    break;
            }


        }

        private void radioButtonZoomSlow_CheckedChanged(object sender, EventArgs e)
        {
            Form1.iPTZSpeed = 0;
        }

        private void radioButtonZoomMed_CheckedChanged(object sender, EventArgs e)
        {
            Form1.iPTZSpeed = 1;
        }

        private void radioButtonZoomFast_CheckedChanged(object sender, EventArgs e)
        {
            Form1.iPTZSpeed = 2;
        }



        private void BtnZoomIn_MouseDown(object sender, MouseEventArgs e)
        {
            switch (Form1.iPTZSpeed)
            {
                case 0:
                    Form1.VALCam_Control(Form1.VC_ZoomInSlow, 0, 0, 0, 0);
                    break;

                case 1:
                    Form1.VALCam_Control(Form1.VC_ZoomIn, 0, 0, 0, 0);
                    break;

                case 2:
                    Form1.VALCam_Control(Form1.VC_ZoomInFast, 0, 0, 0, 0);
                    break;
            }
        }

        private void btnZoomOut_MouseDown(object sender, MouseEventArgs e)
        {
            switch (Form1.iPTZSpeed)
            {
                case 0:
                    Form1.VALCam_Control(Form1.VC_ZoomOutSlow, 0, 0, 0, 0);
                    break;

                case 1:
                    Form1.VALCam_Control(Form1.VC_ZoomOut, 0, 0, 0, 0);
                    break;

                case 2:
                    Form1.VALCam_Control(Form1.VC_ZoomOutFast, 0, 0, 0, 0);
                    break;
            }
        }

        private void BtnZoomIn_MouseUp(object sender, MouseEventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_ZoomStop, 0, 0, 0, 0);
        }

        private void btnZoomOut_MouseUp(object sender, MouseEventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_ZoomStop, 0, 0, 0, 0);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            Form1.iZoomArray = trackBarMeasuredZoom.Value;
            txtMeasuredZoom.Text = Form1.iZoomArray.ToString();
            Form1.VALCam_Control(Form1.VC_ZoomArray, trackBarMeasuredZoom.Value, 0, 0, 0);

        }

        private void radioButtonDIB_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonDIB.Checked == true)
            {
                txtFileName.Enabled = false;
                Form1.iCaptureType = (int)eCaptureType.DIB;
                txtJPGCompression.Enabled = false;
            }

        }

        private void radioButtonDDB_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonDDB.Checked == true)
            {
                txtFileName.Enabled = false;
                Form1.iCaptureType = (int)eCaptureType.DDB;
                txtJPGCompression.Enabled = false;
            }
        }

        private void radioButtonClipBoard_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonClipBoard.Checked == true)
            {
                txtFileName.Enabled = false;
                Form1.iCaptureType = (int)eCaptureType.CLIP_BOARD;
                txtJPGCompression.Enabled = false;
            }
        }

        private void radioButtonBMP_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonBMP.Checked == true)
            {
                txtFileName.Enabled = true;
                Form1.iCaptureType = (int)eCaptureType.BMP;
                txtJPGCompression.Enabled = false;
            }
        }

        private void radioButtonJPG_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonJPG.Checked == true)
            {
                txtFileName.Enabled = true;

                Form1.iCaptureType = (int)eCaptureType.JPG;
                txtJPGCompression.Enabled = true;
                txtJPGCompression.Text = "25";
            }
        }

        private void radioButtonJPGBMP_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonJPGBMP.Checked == true)
            {
                txtFileName.Enabled = true;

                Form1.iCaptureType = (int)eCaptureType.JPGBMP;
                txtJPGCompression.Enabled = true;
                txtJPGCompression.Text = "25";
            }
        }

        private void buttonStructCapture_Click(object sender, EventArgs e)
        {

        }

        private void btnScale_Click(object sender, EventArgs e)
        {

        }

        private void btnCropDefault_Click(object sender, EventArgs e)
        {
            ResizeVideo();

        }

        private void checkBoxMatchScale_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxMatchScale.Checked == true)
            {
                iAutoScale = true;
            }
            else
            {
                iAutoScale = false;
            }

        }

        private void Adjust_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form1.bAdjustDialogOpen = false;
            Form1.iFileName = txtFileName.Text;
            Form1.iJPGCompression = Int32.Parse(txtJPGCompression.Text);
        }

        private void btnLocateFace_Click(object sender, EventArgs e)
        {
            

            if (radioButtonCaptureFromStream.Checked == false)
            {
                Form1.FaceParameters.FileName = txtFileNameToSample.Text;
                Form1.FaceParameters.SampleFromStream = 0;
                Form1.FaceParameters.AutoCenter = 0;
            }
            else
            {
                Form1.FaceParameters.SampleFromStream = 1;
                Form1.FaceParameters.AutoCenter = 1;
            }



            Form1.VALCam_FaceFinder(ref Form1.FaceParameters);
            if (Form1.FaceParameters.FaceFound == 1)
            {

                txtFacePosX.Text = Form1.FaceParameters.FacePositionX.ToString();
                txtFacePosY.Text = Form1.FaceParameters.FacePositionY.ToString();
                txtEyesOpen.Text = Form1.FaceParameters.EyesOpen.ToString();
                txtGlasses.Text = Form1.FaceParameters.Glasses.ToString();
            }
            else
            {
                txtFacePosX.Text = "None";
                txtFacePosY.Text = "None";
                txtFaceWidth.Text = "None";
            }
        }

        private void radioButtonCaptureFromFile_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonCaptureFromFile.Checked == true)
            {
                txtFileNameToSample.Enabled = true;
            }
            else
            {
                txtFileNameToSample.Enabled = false;
            }
        }

        private void hScrollBarFlashColor_Scroll_1(object sender, ScrollEventArgs e)
        {
            Form1.iFlashColorGain = hScrollBarFlashColor.Value;
            Form1.VALCam_Control(Form1.VC_SetColorFlash, Form1.iFlashColorGain, 0, 0, 0);
        }

        private void groupBox9_Enter(object sender, EventArgs e)
        {

        }

        private void XCenterOffset_ValueChanged(object sender, EventArgs e)
        {
            Form1.iXCenterOffset = (int)XCenterOffset.Value;
        }




        public void ResizeVideo()
        {
            switch (Form1.iRotatePosition)
            {
                case 0:
                    txtCropWidth.Text = "625";
                    txtCropHeight.Text = "468";
                    txtXCropOffset.Text = "3";
                    txtYCropOffset.Text = "4";
                    txtDisplayScaleX.Text = "628";
                    txtDisplayScaleY.Text = "468";
                    break;

                case 90:
                    txtCropWidth.Text = "475";
                    txtCropHeight.Text = "625";
                    txtXCropOffset.Text = "2";
                    txtYCropOffset.Text = "4";
                    txtDisplayScaleX.Text = "488";
                    txtDisplayScaleY.Text = "628";
                    break;

                case 270:
                    txtCropWidth.Text = "475";
                    txtCropHeight.Text = "625";
                    txtXCropOffset.Text = "2";
                    txtYCropOffset.Text = "5";
                    txtDisplayScaleX.Text = "475";
                    txtDisplayScaleY.Text = "625";
                    break;
            }
            Form1.iHSize = Int32.Parse(txtCropWidth.Text);
            Form1.iVSize = Int32.Parse(txtCropHeight.Text);
            Form1.iXCropStart = Int32.Parse(txtXCropOffset.Text);
            Form1.iYCropStart = Int32.Parse(txtYCropOffset.Text);
            Form1.iHScale = Int32.Parse(txtDisplayScaleX.Text);
            Form1.iVScale = Int32.Parse(txtDisplayScaleY.Text);
            ResizeVideo2();
            //   Form1.VALCam_Control(Form1.VC_SetCropParameters, Form1.iXCropStart, Form1.iYCropStart, Form1.iHSize, Form1.iVSize);
            //   Form1.VALCam_Control(Form1.VC_DisplayVideo,Form1.iHScale, Form1.iVScale,0,0);
        }

        public void ResizeVideo2()
        {
            Form1.iHSize = Int32.Parse(txtCropWidth.Text);
            Form1.iVSize = Int32.Parse(txtCropHeight.Text);
            Form1.iXCropStart = Int32.Parse(txtXCropOffset.Text);
            Form1.iYCropStart = Int32.Parse(txtYCropOffset.Text);
            Form1.iHScale = Int32.Parse(txtDisplayScaleX.Text);
            Form1.iVScale = Int32.Parse(txtDisplayScaleY.Text);

            if (iAutoScale == true)
            {
                txtDisplayScaleX.Text = txtCropWidth.Text;
                txtDisplayScaleY.Text = txtCropHeight.Text;
                Form1.iHScale = Int32.Parse(txtDisplayScaleX.Text);
                Form1.iVScale = Int32.Parse(txtDisplayScaleY.Text);
            }
            int err = Form1.VALCam_Control(Form1.VC_SetCropParameters, Form1.iXCropStart, Form1.iYCropStart, Form1.iHSize, Form1.iVSize);
            if (err < 1)
                MessageBox.Show("Parameters out of Range", "Error in SetCrop Command", 0);

            else
            {
                Form1.VALCam_Control(Form1.VC_DisplayVideo, 0, 0, Form1.iHScale, Form1.iVScale);
                // m_pParent->ResizeMainWindow();
                if (Form1.iHSize / Form1.iVSize != Form1.iHScale / Form1.iVScale)
                    MessageBox.Show("Aspect Ratio Not Valid", "Warning", 0);
            }
           // Form1Ptr.PositionControls();
        }

        private void radioButtonRotate0_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonRotate0.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_RotateLiveDisplay, 0, 0, 0, 0);
                Form1.iRotatePosition = 0;
                ResizeVideo();
            }

        }

        private void radioButtonRotate90_CheckedChanged_1(object sender, EventArgs e)
        {

            if (radioButtonRotate90.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_RotateLiveDisplay, 90, 0, 0, 0);
                Form1.iRotatePosition = 90;
                ResizeVideo();
            }

        }

        private void radioButtonRotate270_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonRotate270.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_RotateLiveDisplay, 270, 0, 0, 0);
                Form1.iRotatePosition = 270;
                ResizeVideo();
            }
        }

        private void tabPage4_Enter(object sender, EventArgs e)
        {
            txtFileNameToSample.Text = txtFileName.Text;

        }

       /*
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ZoomValue;
            switch (comboBox1.SelectedIndex)
            {
                case 1:
                    ZoomValue = 1 + (int)ZoomType; 
                    break;
                
                case 2:
                    ZoomValue = 2 + (int)ZoomType;
                    break;
                
                case 3:
                    ZoomValue = 3 + (int)ZoomType;
                    break;
                
                case 4:
                    ZoomValue = 4 + (int)ZoomType;
                    break;

                case 5:
                    ZoomValue = 6 + (int)ZoomType;
                    break;

                case 6:
                    ZoomValue = 8 + (int)ZoomType;
                    break;

                case 7:
                    ZoomValue = 10 + (int)ZoomType;
                    break;

                case 8:
                    ZoomValue = 12 + (int)ZoomType;
                    break;
                
                case 9:    
                    ZoomValue = 14 + (int)ZoomType;
                    break;

                case 10:
                    ZoomValue = 16 + (int)ZoomType;
                    break;

                case 11:
                    ZoomValue = 18 + (int)ZoomType;
                    break;

                case 12:
                    ZoomValue = 19 + (int)ZoomType;
                    break;

                case 13:
                    ZoomValue = 22+ (int)ZoomType;
                    break;

                case 14:
                    ZoomValue = 24 + (int)ZoomType;
                    break;

                case 15:
                    ZoomValue = 23 + (int)ZoomType;
                    break;
                case 16:
                    ZoomValue = 27 + (int)ZoomType;
                    break;

                case 17:
                    ZoomValue = 30 + (int)ZoomType;
                    break;

                case 18:
                    ZoomValue = 34 + (int)ZoomType;
                    break;
            
                default:
                    ZoomValue = 37;
                    break;
            
            }
            Form1.VALCam_Control(Form1.VC_ZoomArray,ZoomValue,0,0,0);
        }
        */

        private void radioButtonWide_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonWide.Checked == true)
                ZoomType =eZoomType.Wide;
        }

        private void radioButtonMedium_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonMedium.Checked == true)
                ZoomType =eZoomType. Medium;
        }

        private void radioButtonTight_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonTight.Checked == true)
                ZoomType = eZoomType.Tight;
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
          int ZoomValue;
            switch (listBox1.SelectedIndex)
            {
                case 1:
                    ZoomValue = 1 + (int)ZoomType; 
                    break;
                
                case 2:
                    ZoomValue = 2 + (int)ZoomType;
                    break;
                
                case 3:
                    ZoomValue = 3 + (int)ZoomType;
                    break;
                
                case 4:
                    ZoomValue = 4 + (int)ZoomType;
                    break;

                case 5:
                    ZoomValue = 6 + (int)ZoomType;
                    break;

                case 6:
                    ZoomValue = 8 + (int)ZoomType;
                    break;

                case 7:
                    ZoomValue = 10 + (int)ZoomType;
                    break;

                case 8:
                    ZoomValue = 12 + (int)ZoomType;
                    break;
                
                case 9:    
                    ZoomValue = 14 + (int)ZoomType;
                    break;

                case 10:
                    ZoomValue = 16 + (int)ZoomType;
                    break;

                case 11:
                    ZoomValue = 18 + (int)ZoomType;
                    break;

                case 12:
                    ZoomValue = 19 + (int)ZoomType;
                    break;

                case 13:
                    ZoomValue = 22+ (int)ZoomType;
                    break;

                case 14:
                    ZoomValue = 24 + (int)ZoomType;
                    break;

                case 15:
                    ZoomValue = 23 + (int)ZoomType;
                    break;
                case 16:
                    ZoomValue = 27 + (int)ZoomType;
                    break;

                case 17:
                    ZoomValue = 30 + (int)ZoomType;
                    break;

                case 18:
                    ZoomValue = 34 + (int)ZoomType;
                    break;
            
                default:
                    ZoomValue = 37;
                    break;
            
            }
            Form1.VALCam_Control(Form1.VC_ZoomArray,ZoomValue,0,0,0);        
        }

        private void listBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            int ZoomValue;
            switch (listBox1.SelectedIndex)
            {
                case 0:
                    ZoomValue = 1 + (int)ZoomType;
                    break;

                case 1:
                    ZoomValue = 2 + (int)ZoomType;
                    break;

                case 2:
                    ZoomValue = 3 + (int)ZoomType;
                    break;

                case 3:
                    ZoomValue = 4 + (int)ZoomType;
                    break;

                case 4:
                    ZoomValue = 6 + (int)ZoomType;
                    break;

                case 5:
                    ZoomValue = 8 + (int)ZoomType;
                    break;

                case 6:
                    ZoomValue = 10 + (int)ZoomType;
                    break;

                case 7:
                    ZoomValue = 12 + (int)ZoomType;
                    break;

                case 8:
                    ZoomValue = 14 + (int)ZoomType;
                    break;

                case 9:
                    ZoomValue = 16 + (int)ZoomType;
                    break;

                case 10:
                    ZoomValue = 18 + (int)ZoomType;
                    break;

                case 11:
                    ZoomValue = 19 + (int)ZoomType;
                    break;

                case 12:
                    ZoomValue = 22 + (int)ZoomType;
                    break;

                case 13:
                    ZoomValue = 24 + (int)ZoomType;
                    break;

                case 14:
                    ZoomValue = 23 + (int)ZoomType;
                    break;
                
                case 15:
                    ZoomValue = 27 + (int)ZoomType;
                    break;

                case 16:
                    ZoomValue = 30 + (int)ZoomType;
                    break;

                case 17:
                    ZoomValue = 34 + (int)ZoomType;
                    break;

                default:
                    ZoomValue = 37;
                    break;

            }
            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomValue, 0, 0, 0);    
        }

        private void btnGetPixelIncrement_Click(object sender, EventArgs e)
        {
             int temp= Form1.VALCam_Control(Form1.VC_ReturnZoomPixelIncrement, 0, 0, 0, 0);
             txtPixelIncrement.Text = temp.ToString();
        }

        private void btnShowHideVideo_Click(object sender, EventArgs e)
        {
            if (btnShowHideVideo.Text=="Hide Video")
            {
                Form1.VALCam_Control(Form1.VC_NoVideoDisplay,0,0,0,0);
                btnShowHideVideo.Text="Show Video";
            }
            else
            {
                Form1.VALCam_Control(Form1.VC_SendWindowHandle,(int) Form1.HANDLE, 0, 0, 0);
                Form1.VALCam_Control(Form1.VC_DisplayVideo, 0, 0,Form1.iHScale, Form1.iVScale);
                btnShowHideVideo.Text = "Hide Video";
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }

        private void AutoAdjustZoom_Click(object sender, EventArgs e)
        {
          //  Form1.structFaceFinder FaceParameters;
            Form1.structFaceFinder FACE=new Form1.structFaceFinder();
            int ZoomPixelIncrement;
            bool FirstTime =true;
            int error = 0;
            int FaceFound;
            FACE.SampleFromStream = 1;
            FACE.AutoCenter = 0;
            int EyeDistance=0;
            int ZoomArrayValue=Form1.VALCam_Control(Form1.VC_ReturnZoomArray,0,0,0,0);
          //  MessageBox.Show("ZoomArrayValue = " + ZoomArrayValue.ToString());
            while (EyeDistance < 90)
            {
                FaceFound = 0;
                try
                {
                    FACE.SampleFromStream = 1;
                    FACE.AutoCenter = 0;
                    FACE.FaceFound = 0;
                    Thread.Sleep(300);
                    Form1.VALCam_FaceFinder(ref FACE);
                    Thread.Sleep(300);
                    // MessageBox.Show(error.ToString());

                    FaceFound = FACE.FaceFound;
                    EyeDistance = (int)FACE.EyeDistance;
                }
                catch (System.AccessViolationException)
                {
                    MessageBox.Show("Exception");
                    // FACE = new Form1.structFaceFinder();
                    //FACE.SampleFromStream = 1;
                    //FACE.AutoCenter = 0;
                    //EyeDistance = 0;
                    //FaceFound = 1;
                    error = 1;
                    break;
                }

                if (FaceFound == 0)
                {
                    MessageBox.Show("No Face Found");
                    break;
                }



                if (EyeDistance < 90)
                {
                    if (FirstTime == true)
                    {
                        FirstTime = false;
                        ZoomArrayValue = ZoomArrayValue + 1;
                    }
                    else
                    {

                        ZoomPixelIncrement = Form1.VALCam_Control(Form1.VC_ReturnZoomPixelIncrement, 0, 0, 0, 0);
                        int EyeDistanceRatio = (int)((90 - EyeDistance) / (ZoomPixelIncrement));

                        if (EyeDistanceRatio < 0)
                        {
                            break;
                        }


                        if (EyeDistanceRatio <= 1)
                        {
                            ZoomArrayValue = ZoomArrayValue + 1;
                            //break;
                        }

                        if (EyeDistanceRatio > 1)
                        {
                            ZoomArrayValue = ZoomArrayValue + EyeDistanceRatio;
                            // break;
                        }

                    }
                    Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                    Thread.Sleep(200);
                }
                else
                    break;
                //Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                // MessageBox.Show("Incrementing Zoom Array");
              //  Thread.Sleep(200);
               
            }

            if (error == 0)
            {
                EyeDistance = (int)FACE.EyeDistance;
                MessageBox.Show("Final EyeDistance = " + EyeDistance.ToString());
            }  
        }      

       

       
        
        
    }
}
