using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace VALCam_SDK_2005_Sample_1
{
    public partial class AdjustFlashColor : Form
    {
        public Form1 Form1Ptr;
        public AdjustFlashColor()
        {
            InitializeComponent();
        }

        private void AdjustFlashColor_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form1.bDialogOpen = false;
        }

        private void numericUpDownFlashRed_ValueChanged(object sender, EventArgs e)
        {
            Form1.iFlashRedGain = (int)numericUpDownFlashRed.Value;
            Form1.VALCam_Control(Form1.VC_SetRedFlash, Form1.iFlashRedGain, 0, 0, 0);
        }

        private void numericUpDownFlashBlue_ValueChanged(object sender, EventArgs e)
        { 
            Form1.iFlashBlueGain =(int) numericUpDownFlashBlue.Value;
            Form1.VALCam_Control(Form1.VC_SetBlueFlash, Form1.iFlashBlueGain, 0, 0, 0);

        }

        private void numericUpDownFlashColor_ValueChanged(object sender, EventArgs e)
        {
            Form1.iFlashColorGain =(int) numericUpDownFlashColor.Value;
            Form1.VALCam_Control(Form1.VC_SetColorFlash, Form1.iFlashColorGain, 0, 0, 0);
        }

        private void btnFlashCapture_Click(object sender, EventArgs e)
        {
            Form1.structCaptureConfiguration CaptureConfiguration = new Form1.structCaptureConfiguration();

            CaptureConfiguration.PreviewCapture = 1;
            CaptureConfiguration.Shaprness = Form1.iCaptureSharpness;
            CaptureConfiguration.CaptureType = 2; //Clipboard Capture
            CaptureConfiguration.FlashOn = 1;//Flash On 
            Form1.VALCam_Capture(ref CaptureConfiguration);

            Form1.VALCam_Control(Form1.VC_Freeze, 0, 1, 0, 0);
            
            Form1.VALCam_Control(Form1.VC_DisplayCapture, (int)Form1Ptr.Handle, 0, 0, 0);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form1.VALCam_Control(Form1.VC_DiscardPreviewImage, 0, 0, 0, 0);
            Form1.VALCam_Control(Form1.VC_Freeze, 1, 0, 0, 0);
        }

        private void checkBoxFlourscent_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxFlourscent.Checked == true)
            {
                Form1.VALCam_Control(Form1.VC_SetFlashColorCorrectionType, 1, 0, 0, 0);
                Form1.iFlashCorrectionType = 1;
            }
            else
            {
                Form1.VALCam_Control(Form1.VC_SetFlashColorCorrectionType, 0, 0, 0, 0);
                Form1.iFlashCorrectionType = 0;
            }
        }

        private void btnDefault_Click(object sender, EventArgs e)
        {
            checkBoxFlourscent.Checked = true;
            
            Form1.iFlashRedGain = 0;
            numericUpDownFlashRed.Value = 0;

            Form1.iFlashBlueGain = 0;
            numericUpDownFlashBlue.Value = 0;
            
            Form1.iFlashColorGain = 75;
            numericUpDownFlashColor.Value = 75;
        }

        private void AdjustFlashColor_Load(object sender, EventArgs e)
        {
            numericUpDownFlashBlue.Value=Form1.iFlashBlueGain;
            numericUpDownFlashRed.Value = Form1.iFlashRedGain;
            numericUpDownFlashColor.Value = Form1.iFlashColorGain;
            
            if (Form1.iFlashCorrectionType==1)
             checkBoxFlourscent.Checked=true;
            
            if (Form1.iFlashCorrectionType==0)
             checkBoxFlourscent.Checked=false;
        }
    }
}