using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace VALCam_SDK_2005_Sample_1
{
    public partial class AdjustZoom : Form
    {
        public Form1 Form1Ptr;
        public int MinEyePixels = 95;
        public int MaxEyePixels = 110;
        public AdjustZoom()
        {
            InitializeComponent();
            Form1.bDialogOpen = true;
        }

        private void AdjustZoom_FormClosed(object sender, FormClosedEventArgs e)
        {
            Form1.bDialogOpen = false;
        }

        private void AdjustZoom_Load(object sender, EventArgs e)
        {
            trackBarAdjustZoom.Value = Form1.iZoomArray;
            txtZoomArrayValue.Text = Form1.iZoomArray.ToString();
            txtMaxEyePixels.Text = MaxEyePixels.ToString();
            txtMinEyePixels.Text = MinEyePixels.ToString();
            checkBoxFastZoom.Checked = true;
        }

        private void trackBarAdjustZoom_ValueChanged(object sender, EventArgs e)
        {
            Form1.iZoomArray = trackBarAdjustZoom.Value;
            Form1.VALCam_Control(Form1.VC_ZoomArray, Form1.iZoomArray, 0, 0, 0);
            txtZoomArrayValue.Text = Form1.iZoomArray.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int ZoomPixelIncrement;
            bool FirstTime = true;
            int error = 0;
            int FaceFound;
           // Form1.structFaceFinder FaceParameters= new  Form1.structFaceFinder() ;

            Form1.FaceParameters.SampleFromStream = 1;
            Form1.FaceParameters.AutoCenter = 0;
            Form1.FaceParameters.FileName = "Dummy.jpg";
            int EyeDistance = 0;
            int ZoomArrayValue = Form1.VALCam_Control(Form1.VC_ReturnZoomArray, 0, 0, 0, 0);
            int FirstCapture=0;
            int SecondCapture=0;
            
            
            while ((EyeDistance > MaxEyePixels) || (EyeDistance < MinEyePixels))
            {
                txtMeasureEyePixels.Text = "NA";
                FaceFound = 0;
                try
                {
                    Form1.FaceParameters.SampleFromStream = 1;

                    if (checkBoxAutoCenter.Checked == true)
                    {
                        Form1.FaceParameters.AutoCenter = 1;
                    }
                    else
                    {
                        Form1.FaceParameters.AutoCenter = 0;
                    }
                    Form1.FaceParameters.FaceFound = 0;
                    Form1.VALCam_FaceFinder(ref Form1.FaceParameters);
                   Thread.Sleep(300);

                    FaceFound = Form1.FaceParameters.FaceFound;
                    EyeDistance = (int)Form1.FaceParameters.EyeDistance;
                }
                catch (System.AccessViolationException)
                {
                    MessageBox.Show("Exception");
                    error = 1;
                    break;
                }

                if (FaceFound == 0)
                {
                    MessageBox.Show(" Failure. No Face Found. Verify subject is properly positioned." +  '\n' +  
                        
                        " Manually Zoom in or out for average eyedistance." + '\n' +
                        " Click Auto Zoom Adjust again");
                    error = 1;
                    break;
                }



                if (EyeDistance < MinEyePixels)
                {
                    if (FirstTime == true)
                    {
                        FirstTime = false;
                        ZoomArrayValue = ZoomArrayValue + 1;
                        FirstCapture = EyeDistance;
                        
                        Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                     Thread.Sleep(300);
                    }
                    else
                    {
                        SecondCapture = EyeDistance;
                        ZoomPixelIncrement = SecondCapture - FirstCapture;
                        if (checkBoxFastZoom.Checked == true)
                        {
                          //  ZoomPixelIncrement = Form1.VALCam_Control(Form1.VC_ReturnZoomPixelIncrement, 0, 0, 0, 0);
                            int EyeDistanceRatio = (int)((MinEyePixels - EyeDistance) / (ZoomPixelIncrement));

                            if (EyeDistanceRatio <= 1)
                            {
                                ZoomArrayValue = ZoomArrayValue + 1;
                                //break;
                            }

                            if (EyeDistanceRatio > 1)
                            {
                                ZoomArrayValue = ZoomArrayValue + EyeDistanceRatio;
                                // break;
                            }
                            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                          Thread.Sleep(300);
                        }
                        
                        else  //checkBoxFastZoom.Checked == false
                        {
                            ZoomArrayValue = ZoomArrayValue + 1;
                            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                           Thread.Sleep(300);
                        }
                    }


                }
                if (EyeDistance > MaxEyePixels)
                {
                    if (FirstTime == true)
                    {
                        FirstTime = false;
                        ZoomArrayValue = ZoomArrayValue - 1;
                        FirstCapture = EyeDistance;

                        Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                       Thread.Sleep(300);
                    }
                    else
                    {
                        SecondCapture = EyeDistance;
                        ZoomPixelIncrement = FirstCapture - SecondCapture;
                        if (checkBoxFastZoom.Checked == true)
                        {
                            //  ZoomPixelIncrement = Form1.VALCam_Control(Form1.VC_ReturnZoomPixelIncrement, 0, 0, 0, 0);
                            int EyeDistanceRatio = (int)((EyeDistance - MaxEyePixels) / (ZoomPixelIncrement));

                            if (EyeDistanceRatio <= 1)
                            {
                                ZoomArrayValue = ZoomArrayValue - 1;
                                //break;
                            }

                            if (EyeDistanceRatio > 1)
                            {
                                ZoomArrayValue = ZoomArrayValue - EyeDistanceRatio;
                                // break;
                            }
                            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                            Thread.Sleep(300);
 
                        
                        
                        
                        /*
                        if (checkBoxFastZoom.Checked == true)
                        {
                            ZoomPixelIncrement = Form1.VALCam_Control(Form1.VC_ReturnZoomPixelIncrement, 0, 0, 0, 0);
                            int EyeDistanceRatio = (int)((90 - EyeDistance) / (ZoomPixelIncrement));

                            if (EyeDistanceRatio <= 1)
                            {
                                ZoomArrayValue = ZoomArrayValue - 1;
                                //break;
                            }

                            if (EyeDistanceRatio > 1)
                            {
                                ZoomArrayValue = ZoomArrayValue - EyeDistanceRatio;
                                // break;
                            }
                            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                        */
                        }
                        else  //checkBoxFastZoom.Checked == false
                        {
                            ZoomArrayValue = ZoomArrayValue - 1;
                            Form1.VALCam_Control(Form1.VC_ZoomArray, ZoomArrayValue, 0, 0, 0);
                        }
                    }
                }
            }

           

            if (error == 0)
            {
                EyeDistance = (int)Form1.FaceParameters.EyeDistance;
                txtMeasureEyePixels.Text = EyeDistance.ToString();
                trackBarAdjustZoom.Value = ZoomArrayValue;
                txtZoomArrayValue.Text = ZoomArrayValue.ToString();
                MessageBox.Show("Auto Zoom Finished");
            }
            else //error =1
            {
                EyeDistance = 0;
                txtMeasureEyePixels.Text = "Error";
            }
        }

       
    }

}
              
