using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace VALCam_SDK_2005_Sample_1
{
    public partial class Form1 : Form
    {
        public bool m_AZ = false;
        public bool m_AFI = false;
        public bool m_FC = false;
        public bool m_LA = false;
       

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
              
            
            ErrorLevel = VALCam_Control(VC_VerifySystemInitialized, 0, 0, 0, 0);
           /*
            switch (ErrorLevel)
            {
                case 5:
                    MessageBox.Show("System Initialized and Camera Found");
                    break;
                case -2:
                    MessageBox.Show("System Not Initialized");
                    break;
                default:
                    MessageBox.Show("System Initialized and Camera NOT Found");
                    break;
            }
            */
            iScreenXResolution = GetSystemMetrics(0);
            iScreenYResolution = GetSystemMetrics(1);

            ErrorLevel = VALCam_Control(VC_InitSystem, (int)this.Handle, 0, 0, 0);
            if (ErrorLevel < 1)
            {
                MessageBox.Show("Error in VC_InitSystem Call, Quit APP and fix problem");
                VALCam_Control(VC_CloseCard, 0, 0, 0, 0);
                Close();   
            }
            
            /*
            ErrorLevel=VALCam_Control(VC_VerifySystemInitialized, 0,0,0,0);
            switch (ErrorLevel)
            {
                case 5:
                    MessageBox.Show("System Initialized and Camera Found");
                    break;
                case -2:
                    MessageBox.Show("System Not Initialized");
                    break;
                default:
                    MessageBox.Show("System Initialized and Camera NOT Found");
                    break;
            }
            */
           // VALCam_Control(VC_RotateLiveDisplay, iRotatePosition, 0, 0, 0);
            ReadCurrentParameters();

           // hScrollBarMeasuredZoom.Value = iZoomArray;
            VALCam_Control(VC_ZoomArray, iZoomArray, 0, 0, 0);
           
            iPreview = 1;
            iXCropStart = 3;
            iYCropStart = 4;
            iHSize = 625;
            iVSize = 468;
            iHScale = iHSize;
            iVScale = iVSize;
            ErrorLevel = VALCam_Control(VC_SetCropParameters, iXCropStart, iYCropStart, iHSize, iVSize);

            this.Width = iHScale + 150;
            this.Height = iVScale + 60;
        //    PositionControls();
            
            //************************** Set Window Handle to respond to events on the Live Video Window **************
            VALCam_Control(VC_MessageDrainHnd, (int)this.Handle, 0, 0, 0); //Send Handle of Window to display to Dll
            //***************************************************************************************************


            ErrorLevel = VALCam_Control(VC_DisplayVideo, 0, 0, iHScale, iVScale);
            if (ErrorLevel < 0)
            {
                MessageBox.Show("Error Displaying Live Video = ", ErrorLevel.ToString());
                VALCam_Control(VC_CloseCard, 0, 0, 0, 0);
            }
            HANDLE =(int) this.Handle;

            groupBox1.Location = new Point(iHSize + 5, 10);
           // groupBox1.Location.Y = iVSize + 10;

        }



        private void ReadCurrentParameters()
        {
            VALCam_ReadReturnParameters(ref ReturnValues);


            iColorGain = ReturnValues.ReturnLiveColor;
            iRedGain = ReturnValues.ReturnLiveRed;
            iBlueGain = ReturnValues.ReturnLiveBlue;

           // radioButtonOff.Checked = true; //Default to Flash Off
            iAutoWhite = ReturnValues.ReturnAutoWhite;

            iFlashColorGain = ReturnValues.ReturnFlashColor;

            iFlashRedGain = ReturnValues.ReturnFlashRed;
            iFlashBlueGain = ReturnValues.ReturnFlashBlue;

            iFlashIrisLevel = ReturnValues.ReturnFlashIris;
         //   numericUpDownFlashIris.Value = iFlashIrisLevel;

            FGSharpness = ReturnValues.ReturnFGSharpness;
            iCaptureSharpness = ReturnValues.ReturnSharpness;

            iFlashCorrectionType = ReturnValues.ReturnFlashCorrection;
            if (iFlashCorrectionType > 1)
                iFlashCorrectionType = 1;
            if (iFlashCorrectionType<0)
                iFlashCorrectionType = 0;

            iLiveBrightnessLevel = ReturnValues.ReturnLiveIrisLevel;
        //    hScrollBarLiveExposure.Value = iLiveBrightnessLevel;

           
            iRedColorCorrect =  ReturnValues.ReturnRedPaint;
          //  txtRedPaint.Text = iRedColorCorrect.ToString();

            //vScrollBarBluePaint.Value = -(BlueColorCorrection);
            
            iBlueColorCorrect =  ReturnValues.ReturnBluePaint;
         //  txtBluePaint.Text = iBlueColorCorrect.ToString();

            iZoomArray = VALCam_Control(VC_ReturnZoomArray, 0, 0, 0, 0);
            //txtZoom.Text = iZoomArray.ToString();
       
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

            VALCam_Control(VC_NoVideoDisplay, 0, 0, 0, 0);
            VALCam_Control(VC_CloseCard, (int)Handle, 0, 0, 0);
        }




        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.X < iHSize && e.Y < iVSize)
            {
                if (MouseClick == 0)
                {
                    MouseClick = 1;
                    timer1.Enabled = true;
                    return;
                }
                if ((MouseClick == 1) && (timer1.Enabled == true))
                {
                    timer1.Enabled = false;
                    MouseClick = 0;
                    double iScalingiCorrectionScalingFactor = ((double)iHSize / (double)iHScale); // Could also be iVSize/iVScale
                    int mouseXCorrected = (int)(iScalingiCorrectionScalingFactor * (double)(e.X));
                    int mouseYCorrected = (int)(iScalingiCorrectionScalingFactor * (double)(e.Y));

                    switch (iRotatePosition)
                    {

                        case 0://0 Degress
                            
                        
                            VALCam_Control(VC_SetPTZPosition, (iHSize / 2 + iXCenterOffset) - mouseXCorrected, mouseYCorrected - (iVSize / 2), 0, 0);
                            break;
                        case 90://90 Degrees
                        
                            VALCam_Control(VC_SetPTZPosition, -(mouseYCorrected - (iVSize / 2 - iYCenterOffset)), ((iHSize / 2 + iXCenterOffset) - mouseXCorrected), 0, 0);
                            break;
                        case 270: //270 Degrees
                        
                            VALCam_Control(VC_SetPTZPosition, (mouseYCorrected - (iVSize / 2 - iYCenterOffset)), -((iHSize / 2 + iXCenterOffset) - mouseXCorrected), 0, 0);
                            break;
                        
                    }
                }
            }

            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            MouseClick = 0;
        }



       



        
        
        
       
       
      


      

      

        private void btnDefaultColorCorrect_Click(object sender, EventArgs e)
        {
           /*
            vScrollBarRedPaint.Value = 0;
            vScrollBarBluePaint.Value = 0;
            //VALCam_Control(VC_ColorCorrectImage, iRedColorCorrect, -iBlueColorCorrect, 0, 0);
            */
        }

        private void txtFacePositionY_TextChanged(object sender, EventArgs e)
        {

        }

        private void lblFacePositionY_Click(object sender, EventArgs e)
        {

        }

        private void btnAdjustZoom_Click(object sender, EventArgs e)
        {
            if (bDialogOpen == false)
            {
                bDialogOpen = true;
                this.Location = new Point(5, iScreenYResolution / 2 - this.Height / 2);
                dlgAdjustZoom = new AdjustZoom();
                dlgAdjustZoom.Form1Ptr = this;
                dlgAdjustZoom.Show();
                dlgAdjustZoom.Location = new Point(this.Location.X + this.Width, this.Location.Y);
            }
            else
                MessageBox.Show("Close Open Dialog Box");
        }

        private void btnAdjustFlashLevel_Click(object sender, EventArgs e)
        {
            if (bDialogOpen == false)
            {
                bDialogOpen = true;
                this.Location = new Point(5, iScreenYResolution / 2 - this.Height / 2);
                dlgAdjustFlashBrightness = new AdjustFlashBrightness();
                dlgAdjustFlashBrightness.Form1Ptr = this;
                dlgAdjustFlashBrightness.Show();
                dlgAdjustFlashBrightness.Location = new Point(this.Location.X + this.Width, this.Location.Y);
                
            }
            else
                MessageBox.Show("Close Open Dialog Box");
        }

        private void btnAdjustFlashColor_Click(object sender, EventArgs e)
        {

            if (bDialogOpen == false)
            {
                bDialogOpen = true;
                this.Location = new Point(5, iScreenYResolution / 2 - this.Height / 2);
                dlgAdjustFlashColor = new AdjustFlashColor();
                dlgAdjustFlashColor.Form1Ptr = this;
                dlgAdjustFlashColor.Show();
                dlgAdjustFlashColor.Location = new Point(this.Location.X + this.Width, this.Location.Y);

            }
            else
                MessageBox.Show("Close Open Dialog Box");
        }

        private void btnLiveAdjustments_Click(object sender, EventArgs e)
        {
            if (bDialogOpen == false)
            {
                bDialogOpen = true;
                this.Location = new Point(5, iScreenYResolution / 2 - this.Height / 2);
                dlgLiveAdjustments = new LiveAdjustments();
                dlgLiveAdjustments.Form1Ptr = this;
                dlgLiveAdjustments.Show();
                dlgLiveAdjustments.Location = new Point(this.Location.X + this.Width, this.Location.Y);
            }
            else
                MessageBox.Show("Close Open Dialog Box");
        }
       
    }
}